## gsad 24.5.4

=== CMakeLists.txt ===
# Copyright (C) 2017-2021 Greenbone AG
#
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.5)

message("-- Configuring gsad")

project(gsad VERSION 24.5.4 LANGUAGES C)

if(NOT DEFINED PROJECT_VERSION_STRING)
  set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
  include(ProjectVersion)
endif()

set(GSAD_VERSION "${PROJECT_VERSION_STRING}")

message(STATUS "Building gsad version ${GSAD_VERSION}")

# Feature toggles

if(NOT ENABLE_AGENTS)
  set(ENABLE_AGENTS 0)
endif(NOT ENABLE_AGENTS)
add_definitions(-DENABLE_AGENTS=${ENABLE_AGENTS})

if(NOT ENABLE_CONTAINER_SCANNING)
  set(ENABLE_CONTAINER_SCANNING 0)
endif(NOT ENABLE_CONTAINER_SCANNING)
add_definitions(-DENABLE_CONTAINER_SCANNING=${ENABLE_CONTAINER_SCANNING})

## Code coverage

option(ENABLE_COVERAGE "Enable support for coverage analysis" OFF)
if(ENABLE_COVERAGE)
  set(COVERAGE_FLAGS "--coverage -ftest-coverage -fprofile-arcs")
  set(COVERAGE_DIR "${CMAKE_BINARY_DIR}/coverage")
  file(MAKE_DIRECTORY ${COVERAGE_DIR})
  message("-- Code Coverage enabled")
endif(ENABLE_COVERAGE)

## Files generated on installation

# generate compile_commands.json file
# see https://clang.llvm.org/docs/JSONCompilationDatabase.html
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

enable_testing()

## make format
message(STATUS "Looking for clang-format...")
find_program(CLANG_FORMAT clang-format)

if(CLANG_FORMAT)
  message(STATUS "Looking for clang-format... ${CLANG_FORMAT}")
  add_custom_target(
    format
    COMMAND ${CLANG_FORMAT} "-i" "./src/*.c" "./src/*.h"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
else(CLANG_FORMAT)
  message(STATUS "clang-format not found.")
endif(CLANG_FORMAT)

if(NOT SYSCONFDIR)
  set(SYSCONFDIR "/etc")
endif(NOT SYSCONFDIR)

if(NOT EXEC_PREFIX)
  set(EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
endif(NOT EXEC_PREFIX)

if(NOT BINDIR)
  set(BINDIR "${EXEC_PREFIX}/bin")
endif(NOT BINDIR)

if(NOT SBINDIR)
  set(SBINDIR "${EXEC_PREFIX}/sbin")
endif(NOT SBINDIR)

if(NOT LIBDIR)
  set(LIBDIR "${EXEC_PREFIX}/lib")
endif(NOT LIBDIR)

if(NOT LOCALSTATEDIR)
  set(LOCALSTATEDIR "/var")
endif(NOT LOCALSTATEDIR)

if(NOT INCLUDEDIR)
  set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")
endif(NOT INCLUDEDIR)

if(NOT DATADIR)
  set(DATADIR "${CMAKE_INSTALL_PREFIX}/share")
endif(NOT DATADIR)

set(GSAD_DATA_DIR "${DATADIR}/gvm/gsad")
set(GSAD_CONFIG_DIR "${SYSCONFDIR}/gvm/")

if(NOT GSAD_RUN_DIR)
  set(GSAD_RUN_DIR "/run/gsad")
endif(NOT GSAD_RUN_DIR)

if(NOT GSAD_PID_PATH)
  set(GSAD_PID_PATH "${GSAD_RUN_DIR}/gsad.pid")
endif(NOT GSAD_PID_PATH)

if(NOT GVMD_RUN_DIR)
  set(GVMD_RUN_DIR "/run/gvmd")
endif(NOT GVMD_RUN_DIR)

if(NOT GVM_STATE_DIR)
  set(GVM_STATE_DIR "${LOCALSTATEDIR}/lib/gvm")
else(NOT GVM_STATE_DIR)
  set(GVM_STATE_DIR "${GVM_STATE_DIR}")
endif(NOT GVM_STATE_DIR)

if(NOT GSAD_LOG_FILE)
  if(GVM_LOG_DIR)
    set(GSAD_LOG_FILE "${GVM_LOG_DIR}/gsad.log")
  else(GVM_LOG_DIR)
    set(GSAD_LOG_FILE "-")
  endif(GVM_LOG_DIR)
endif(NOT GSAD_LOG_FILE)

if(NOT GVM_SERVER_CERTIFICATE)
  set(GVM_SERVER_CERTIFICATE "${GVM_STATE_DIR}/CA/servercert.pem")
else(NOT GVM_SERVER_CERTIFICATE)
  set(GVM_SERVER_CERTIFICATE "${GVM_SERVER_CERTIFICATE}")
endif(NOT GVM_SERVER_CERTIFICATE)

if(NOT GVM_SERVER_KEY)
  set(GVM_SERVER_KEY "${GVM_STATE_DIR}/private/CA/serverkey.pem")
else(NOT GVM_SERVER_KEY)
  set(GVM_SERVER_KEY "${GVM_SERVER_KEY}")
endif(NOT GVM_SERVER_KEY)

if(NOT GVM_CA_CERTIFICATE)
  set(GVM_CA_CERTIFICATE "${GVM_STATE_DIR}/CA/cacert.pem")
else(NOT GVM_CA_CERTIFICATE)
  set(GVM_CA_CERTIFICATE "${GVM_CA_CERTIFICATE}")
endif(NOT GVM_CA_CERTIFICATE)

configure_file(src/gsad_log_conf.cmake_in src/gsad_log.conf)

## Install

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/src/gsad_log.conf
  DESTINATION ${GSAD_CONFIG_DIR}
)

add_subdirectory(src)
add_subdirectory(config)

add_subdirectory(doc)

# vim: set ts=2 sw=2 tw=80:

=== config/CMakeLists.txt ===
# Copyright (C) 2019-2021 Greenbone AG
#
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

if(NOT SYSTEMD_SERVICE_DIR)
  set(SYSTEMD_SERVICE_DIR "${LIBDIR}/systemd/system")
endif(NOT SYSTEMD_SERVICE_DIR)

message(STATUS "Installing systemd service files to ${SYSTEMD_SERVICE_DIR}")

if(NOT LOGROTATE_DIR)
  set(LOGROTATE_DIR "${SYSCONFDIR}/logrotate.d")
endif(NOT LOGROTATE_DIR)

configure_file(gsad.service.in gsad.service)
configure_file(gsad.logrotate.in gsad.logrotate)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/gsad.service
  DESTINATION ${SYSTEMD_SERVICE_DIR}/
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/gsad.logrotate
  DESTINATION ${LOGROTATE_DIR}/
  RENAME gsad
)

=== doc/CMakeLists.txt ===
# Copyright (C) 2009-2021 Greenbone AG#
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

## build

set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM true)
set_directory_properties(
  PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ".built-html;.built-html_full"
)

include(FindDoxygen)

# Configure Doxyfile with version number
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile_full.in
  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_full
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile_xml.in
  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_xml
)

if(NOT DOXYGEN_EXECUTABLE)
  message(STATUS "WARNING: Doxygen is required to build the HTML docs.")
else(NOT DOXYGEN_EXECUTABLE)
  add_custom_target(
    doc
    COMMENT "Building documentation..."
    DEPENDS
      ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      ${CMAKE_CURRENT_BINARY_DIR}/.built-html
  )

  add_custom_command(
    OUTPUT .built-html
    COMMAND sh
    ARGS
      -c \"${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile && touch
      ${CMAKE_CURRENT_BINARY_DIR}/.built-html\;\"
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
  )

  add_custom_target(
    doc-full
    COMMENT "Building documentation..."
    DEPENDS
      ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_full
      ${CMAKE_CURRENT_BINARY_DIR}/.built-html_full
  )

  add_custom_command(
    OUTPUT .built-html_full
    COMMAND sh
    ARGS
      -c \"${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_full &&
      touch ${CMAKE_CURRENT_BINARY_DIR}/.built-html_full\;\"
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_full
  )

  add_custom_target(
    doc-xml
    COMMENT "Building documentation (XML)..."
    DEPENDS
      ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_xml
      ${CMAKE_CURRENT_BINARY_DIR}/.built-xml
  )

  add_custom_command(
    OUTPUT .built-xml
    COMMAND sh
    ARGS
      -c \"${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_xml &&
      touch ${CMAKE_CURRENT_BINARY_DIR}/.built-xml\;\"
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_xml
  )
endif(NOT DOXYGEN_EXECUTABLE)

## Find xml2man

message(STATUS "Looking for xmltoman...")

find_program(
  XMLTOMAN_EXECUTABLE
  xmltoman
  PATHS /bin /usr/bin /usr/local/bin/
  DOC "xmltoman location"
)

message(STATUS "Looking for xmltoman... ${XMLTOMAN_EXECUTABLE}")

find_program(
  XMLMANTOHTML_EXECUTABLE
  xmlmantohtml
  PATHS /bin /usr/bin /usr/local/bin/
  DOC "xmlmantohtml location"
)

message(STATUS "Looking for xmlmantohtml... ${XMLMANTOHTML_EXECUTABLE}")

# FIX find_program seems to follow symlink
if(XMLMANTOHTML_EXECUTABLE)
  set(XMLMANTOHTML_EXECUTABLE xmlmantohtml)
endif(XMLMANTOHTML_EXECUTABLE)

if(XMLTOMAN_EXECUTABLE)
  add_custom_target(man COMMENT "Building manual page..." DEPENDS gsad.8)

  add_custom_command(
    OUTPUT gsad.8
    COMMAND sh
    ARGS
      -c \"${XMLTOMAN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/gsad.8.xml >
      ${CMAKE_CURRENT_BINARY_DIR}/gsad.8\;\"
    DEPENDS gsad.8.xml
  )
else(XMLTOMAN_EXECUTABLE)
  message(STATUS "WARNING: xmltoman is required to generate manpage.")
  add_custom_command(
    OUTPUT gsad.8
    COMMAND
      echo "[Error: xmltoman required to see manpage here]" >
      ${CMAKE_CURRENT_BINARY_DIR}/gsad.8
  )
endif(XMLTOMAN_EXECUTABLE)

if(XMLMANTOHTML_EXECUTABLE)
  add_custom_target(
    man-html
    COMMENT "Building manual page HTML..."
    DEPENDS gsad.html
  )

  add_custom_command(
    OUTPUT gsad.html
    COMMAND sh
    ARGS
      -c \"${XMLMANTOHTML_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/gsad.8.xml >
      ${CMAKE_CURRENT_BINARY_DIR}/gsad.html\;\"
    DEPENDS gsad.8.xml
  )
else(XMLMANTOHTML_EXECUTABLE)
  message(STATUS "WARNING: xmlmantohtml is required for manpage in HTML docs.")
  add_custom_command(
    OUTPUT gsad.html
    COMMAND
      echo "[Error: xmlmantohtml required to see manpage here]" > gsad.html
  )
endif(XMLMANTOHTML_EXECUTABLE)

## Install

install(FILES gsad.8 DESTINATION ${DATADIR}/man/man8)

=== src/CMakeLists.txt ===
# Copyright (C) 2009-2021 Greenbone AG#
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

# Needed for 'pkg_check_modules' function
include(FindPkgConfig)

if(NOT PKG_CONFIG_FOUND)
  message(FATAL_ERROR "pkg-config executable not found. Aborting.")
endif(NOT PKG_CONFIG_FOUND)

## Check for existence of required libraries
pkg_check_modules(LIBMICROHTTPD REQUIRED libmicrohttpd>=0.9.0)
pkg_check_modules(LIBXML REQUIRED libxml-2.0)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.42)
pkg_check_modules(LIBGVM_BASE REQUIRED libgvm_base>=22.8)
pkg_check_modules(LIBGVM_UTIL REQUIRED libgvm_util>=22.8)
pkg_check_modules(LIBGVM_GMP REQUIRED libgvm_gmp>=22.8)
pkg_check_modules(GNUTLS REQUIRED gnutls>=3.2.15)
pkg_check_modules(ZLIB REQUIRED zlib>=1.2)
pkg_check_modules(BROTLI libbrotlienc)

message(STATUS "Looking for libgcrypt...")
pkg_check_modules(GCRYPT REQUIRED libgcrypt)

if(
  NOT LIBMICROHTTPD_FOUND
  OR NOT LIBXML_FOUND
  OR NOT GLIB_FOUND
  OR (GTHREAD_REQUIRED AND NOT GTHREAD_FOUND)
  OR NOT LIBGVM_GMP_FOUND
  OR NOT GNUTLS_FOUND
  OR NOT ZLIB_FOUND
)
  message(
    FATAL_ERROR
    "One or more required libraries was not found "
    "(see message above), please install the missing "
    "libraries and run cmake again."
  )
endif(
  NOT LIBMICROHTTPD_FOUND
  OR NOT LIBXML_FOUND
  OR NOT GLIB_FOUND
  OR (GTHREAD_REQUIRED AND NOT GTHREAD_FOUND)
  OR NOT LIBGVM_GMP_FOUND
  OR NOT GNUTLS_FOUND
  OR NOT ZLIB_FOUND
)

## Program

set(HARDENING_FLAGS "-D_FORTIFY_SOURCE=2 -fstack-protector")
set(LINKER_HARDENING_FLAGS "-Wl,-z,relro -Wl,-z,now")

set(
  CMAKE_C_FLAGS
  "${CMAKE_C_FLAGS} -Wall -Wformat -Wformat-security ${COVERAGE_FLAGS}"
)
if(BROTLI_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_BROTLI=1")
endif(BROTLI_FOUND)

set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -Werror")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${HARDENING_FLAGS}")

include_directories(
  ${LIBMICROHTTPD_INCLUDE_DIRS}
  ${LIBXML_INCLUDE_DIRS}
  ${GLIB_INCLUDE_DIRS}
  ${LIBGVM_BASE_INCLUDE_DIRS}
  ${LIBGVM_UTIL_INCLUDE_DIRS}
  ${LIBGVM_GMP_INCLUDE_DIRS}
  ${GNUTLS_INCLUDE_DIRS}
  ${ZLIB_INCLUDE_DIRS}
  ${BROTLI_INCLUDE_DIRS}
)

find_package(Threads)

## Program

add_executable(
  gsad
  gsad.c
  gsad_base.c
  gsad_cmd.c
  gsad_credentials.c
  gsad_gmp.c
  gsad_gmp_arguments.c
  gsad_gmp_request.c
  gsad_http.c
  gsad_http_handler.c
  gsad_i18n.c
  gsad_session.c
  gsad_settings.c
  gsad_user.c
  gsad_validator.c
  utils.c
  validator.c
)

target_link_libraries(
  gsad
  ${LIBMICROHTTPD_LDFLAGS}
  ${GTHREAD_LDFLAGS}
  ${GLIB_LDFLAGS}
  ${LIBXML_LDFLAGS}
  ${GCRYPT_LDFLAGS}
  ${GNUTLS_LDFLAGS}
  ${ZLIB_LDFLAGS}
  ${BROTLI_LDFLAGS}
  ${LIBGVM_BASE_LDFLAGS}
  ${LIBGVM_UTIL_LDFLAGS}
  ${LIBGVM_GMP_LDFLAGS}
  ${LIBGVM_GMP_LDFLAGS}
  ${CMAKE_THREAD_LIBS_INIT}
  ${LINKER_HARDENING_FLAGS}
)
set_target_properties(gsad PROPERTIES LINKER_LANGUAGE C)

if(GSAD_VERSION)
  add_definitions(-DGSAD_VERSION="${GSAD_VERSION}")
endif(GSAD_VERSION)

if(GVM_SERVER_CERTIFICATE)
  add_definitions(-DGVM_SERVER_CERTIFICATE="${GVM_SERVER_CERTIFICATE}")
endif(GVM_SERVER_CERTIFICATE)

if(GVM_SERVER_KEY)
  add_definitions(-DGVM_SERVER_KEY="${GVM_SERVER_KEY}")
endif(GVM_SERVER_KEY)

if(GVM_CA_CERTIFICATE)
  add_definitions(-DGVM_CA_CERTIFICATE="${GVM_CA_CERTIFICATE}")
endif(GVM_CA_CERTIFICATE)

if(GVMD_RUN_DIR)
  add_definitions(-DGVMD_RUN_DIR="${GVMD_RUN_DIR}")
endif(GVMD_RUN_DIR)

if(GSAD_RUN_DIR)
  add_definitions(-DGSAD_RUN_DIR="${GSAD_RUN_DIR}")
endif(GSAD_RUN_DIR)

if(GSAD_PID_PATH)
  add_definitions(-DGSAD_PID_PATH="${GSAD_PID_PATH}")
endif(GSAD_PID_PATH)

if(GSAD_DATA_DIR)
  add_definitions(-DGSAD_DATA_DIR="${GSAD_DATA_DIR}")
endif(GSAD_DATA_DIR)

if(GSAD_CONFIG_DIR)
  add_definitions(-DGSAD_CONFIG_DIR="${GSAD_CONFIG_DIR}")
endif(GSAD_CONFIG_DIR)

if(GSAD_LOCALE_DIR)
  add_definitions(-DGSAD_LOCALE_DIR="${GSAD_LOCALE_DIR}")
endif(GSAD_LOCALE_DIR)

if(GSAD_CHROOT_LOCALE_DIR)
  add_definitions(-DGSAD_CHROOT_LOCALE_DIR="${GSAD_CHROOT_LOCALE_DIR}")
endif(GSAD_CHROOT_LOCALE_DIR)

add_definitions(-DGVM_OS_NAME="${CMAKE_SYSTEM}")
add_definitions(-DPREFIX="${CMAKE_INSTALL_PREFIX}")

## Install

install(
  TARGETS gsad
  RUNTIME DESTINATION ${SBINDIR}
  LIBRARY DESTINATION ${LIBDIR}
  ARCHIVE DESTINATION ${LIBDIR}/static
)

## Static analysis

add_custom_target(
  cppcheck
  COMMENT "Running cppcheck..."
  COMMAND sh -c \"cppcheck ${CMAKE_CURRENT_SOURCE_DIR}\"
)

add_custom_target(check COMMENT "Checking code...")
add_dependencies(check cppcheck)

## Tag files

set(C_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.c")
add_custom_target(etags COMMENT "Building TAGS..." COMMAND etags ${C_FILES})
add_custom_target(ctags COMMENT "Building tags..." COMMAND ctags ${C_FILES})
add_custom_target(tags COMMENT "Building tags files...")
add_dependencies(tags etags ctags)

## Testing

if(BUILD_TESTING)
  find_package(cgreen REQUIRED)

  add_executable(utils-test EXCLUDE_FROM_ALL utils_test.c)

  add_executable(
    gsad-validator-test
    EXCLUDE_FROM_ALL
    gsad_validator_test.c
    validator.c
  )

  target_link_libraries(gsad-validator-test ${CGREEN_LIBRARIES} ${GLIB_LDFLAGS})
  target_link_libraries(utils-test ${CGREEN_LIBRARIES} ${GLIB_LDFLAGS})

  target_link_libraries(gsad-validator-test ${CGREEN_LIBRARIES} ${GLIB_LDFLAGS})
  add_test(gsad-validator-test gsad-validator-test)
  add_test(utils-test utils-test)

  add_custom_target(tests DEPENDS gsad-validator-test utils-test)
endif(BUILD_TESTING)

if(ENABLE_COVERAGE)
  add_custom_target(
    coverage-html
    COMMAND
      gcovr --html-details ${COVERAGE_DIR}/coverage.html -r ${CMAKE_SOURCE_DIR}
      ${CMAKE_BINARY_DIR}
  )
  add_custom_target(
    coverage-xml
    COMMAND
      gcovr --xml ${COVERAGE_DIR}/coverage.xml -r ${CMAKE_SOURCE_DIR}
      ${CMAKE_BINARY_DIR}
  )
  add_custom_target(coverage DEPENDS coverage-xml coverage-html)
endif(ENABLE_COVERAGE)

add_custom_target(
  clean-coverage
  COMMAND find . -name *.gcda -delete -or -name *.gcno -delete
  COMMAND rm -f ${COVERAGE_DIR}/*
)

## End

=== debian/changelog ===
gsad (24.5.4-2) unstable; urgency=medium

  * Update debian/watch to version 5

 -- Sophie Brun <sophie@kali.org>  Fri, 03 Oct 2025 16:20:29 +0200

gsad (24.5.4-1) unstable; urgency=medium

  * New upstream version 24.5.4
  * debian/copyright: Fix old fsf address

 -- Sophie Brun <sophie@kali.org>  Mon, 25 Aug 2025 11:57:40 +0200

gsad (24.5.3-1) unstable; urgency=medium

  * New upstream version 24.5.3
  * Update my email

 -- Sophie Brun <sophie@kali.org>  Thu, 14 Aug 2025 15:14:53 +0200

=== debian/control ===
Source: gsad
Section: admin
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sophie Brun <sophie@kali.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
	       clang-format,
	       cppcheck,
               libmicrohttpd-dev,
               libgvm-dev (>= 22.8.0),
               libxslt1-dev,
               doxygen,
	       xmltoman,
               pkgconf,
               libxml2-dev
Standards-Version: 4.7.2
Homepage: https://www.greenbone.net
Vcs-Git: https://salsa.debian.org/pkg-security-team/gsad.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/gsad

Package: gsad
Architecture: any
Depends: gvmd (>= 22.5.0),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: greenbone-security-assistant (>= 22.4.0)
Replaces: greenbone-security-assistant (<< 21.4.4)
Breaks: greenbone-security-assistant (<< 21.4.4)
Description: remote network security auditor - web interface
 The Greenbone Security Assistant HTTP Server connects to the Greebone
 Vulnerability Manager "gvmd" to provide a full-featured user interface for
 vulnerability management.
 .
 This tools was initially provided by the package greenbone-security-assistant.

=== debian/watch ===
version: 5
Template: Github
Owner: greenbone
Project: gsad

## gsad 24.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 message("-- Configuring gsad")
 
-project(gsad VERSION 24.5.4 LANGUAGES C)
+project(gsad VERSION 24.7.0 LANGUAGES C)
 
 if(NOT DEFINED PROJECT_VERSION_STRING)
   set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
@@ -34,13 +34,24 @@
 
 if(NOT ENABLE_AGENTS)
   set(ENABLE_AGENTS 0)
+else(NOT ENABLE_AGENTS)
+  message(STATUS "Building with agents feature enabled")
 endif(NOT ENABLE_AGENTS)
 add_definitions(-DENABLE_AGENTS=${ENABLE_AGENTS})
 
 if(NOT ENABLE_CONTAINER_SCANNING)
   set(ENABLE_CONTAINER_SCANNING 0)
+else(NOT ENABLE_CONTAINER_SCANNING)
+  message(STATUS "Building with container image scanning feature enabled")
 endif(NOT ENABLE_CONTAINER_SCANNING)
 add_definitions(-DENABLE_CONTAINER_SCANNING=${ENABLE_CONTAINER_SCANNING})
+
+if(NOT ENABLE_CREDENTIAL_STORES)
+  set(ENABLE_CREDENTIAL_STORES 0)
+else(NOT ENABLE_CREDENTIAL_STORES)
+  message(STATUS "Building with credential stores feature enabled")
+endif(NOT ENABLE_CREDENTIAL_STORES)
+add_definitions(-DENABLE_CREDENTIAL_STORES=${ENABLE_CREDENTIAL_STORES})
 
 ## Code coverage

=== debian/changelog ===
gsad (24.7.0-1) unstable; urgency=medium

  * New upstream version 24.7.0
  * Fix typo in debian/watch

 -- Sophie Brun <sophie@kali.org>  Thu, 06 Nov 2025 09:56:25 +0100

=== debian/watch ===
Version: 5
Template: Github
Owner: greenbone
Project: gsad

## gsad 24.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,11 +15,11 @@
 # You should have received a copy of the GNU Affero General Public License
 # along with this program. If not, see <http://www.gnu.org/licenses/>.
 
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 message("-- Configuring gsad")
 
-project(gsad VERSION 24.7.0 LANGUAGES C)
+project(gsad VERSION 24.12.0 LANGUAGES C)
 
 if(NOT DEFINED PROJECT_VERSION_STRING)
   set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
@@ -29,29 +29,6 @@
 set(GSAD_VERSION "${PROJECT_VERSION_STRING}")
 
 message(STATUS "Building gsad version ${GSAD_VERSION}")
-
-# Feature toggles
-
-if(NOT ENABLE_AGENTS)
-  set(ENABLE_AGENTS 0)
-else(NOT ENABLE_AGENTS)
-  message(STATUS "Building with agents feature enabled")
-endif(NOT ENABLE_AGENTS)
-add_definitions(-DENABLE_AGENTS=${ENABLE_AGENTS})
-
-if(NOT ENABLE_CONTAINER_SCANNING)
-  set(ENABLE_CONTAINER_SCANNING 0)
-else(NOT ENABLE_CONTAINER_SCANNING)
-  message(STATUS "Building with container image scanning feature enabled")
-endif(NOT ENABLE_CONTAINER_SCANNING)
-add_definitions(-DENABLE_CONTAINER_SCANNING=${ENABLE_CONTAINER_SCANNING})
-
-if(NOT ENABLE_CREDENTIAL_STORES)
-  set(ENABLE_CREDENTIAL_STORES 0)
-else(NOT ENABLE_CREDENTIAL_STORES)
-  message(STATUS "Building with credential stores feature enabled")
-endif(NOT ENABLE_CREDENTIAL_STORES)
-add_definitions(-DENABLE_CREDENTIAL_STORES=${ENABLE_CREDENTIAL_STORES})
 
 ## Code coverage

=== debian/changelog ===
gsad (24.12.0-1) unstable; urgency=medium

  * New upstream version 24.12.0

 -- Sophie Brun <sophie@kali.org>  Fri, 05 Dec 2025 11:35:47 +0100

## gsad 24.12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,25 +1,12 @@
 # Copyright (C) 2017-2021 Greenbone AG
 #
 # SPDX-License-Identifier: AGPL-3.0-or-later
-#
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero General Public License as
-# published by the Free Software Foundation, either version 3 of the
-# License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero General Public License for more details.
-#
-# You should have received a copy of the GNU Affero General Public License
-# along with this program. If not, see <http://www.gnu.org/licenses/>.
 
 cmake_minimum_required(VERSION 3.10)
 
 message("-- Configuring gsad")
 
-project(gsad VERSION 24.12.0 LANGUAGES C)
+project(gsad VERSION 24.12.2 LANGUAGES C)
 
 if(NOT DEFINED PROJECT_VERSION_STRING)
   set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

=== config/CMakeLists.txt ===
# Copyright (C) 2019-2021 Greenbone AG
#
# SPDX-License-Identifier: AGPL-3.0-or-later

if(NOT SYSTEMD_SERVICE_DIR)
  set(SYSTEMD_SERVICE_DIR "${LIBDIR}/systemd/system")
endif(NOT SYSTEMD_SERVICE_DIR)

message(STATUS "Installing systemd service files to ${SYSTEMD_SERVICE_DIR}")

if(NOT LOGROTATE_DIR)
  set(LOGROTATE_DIR "${SYSCONFDIR}/logrotate.d")
endif(NOT LOGROTATE_DIR)

configure_file(gsad.service.in gsad.service)
configure_file(gsad.logrotate.in gsad.logrotate)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/gsad.service
  DESTINATION ${SYSTEMD_SERVICE_DIR}/
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/gsad.logrotate
  DESTINATION ${LOGROTATE_DIR}/
  RENAME gsad
)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,6 @@
-# Copyright (C) 2009-2021 Greenbone AG#
+# Copyright (C) 2009-2021 Greenbone AG
+#
 # SPDX-License-Identifier: AGPL-3.0-or-later
-#
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero General Public License as
-# published by the Free Software Foundation, either version 3 of the
-# License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero General Public License for more details.
-#
-# You should have received a copy of the GNU Affero General Public License
-# along with this program. If not, see <http://www.gnu.org/licenses/>.
 
 ## build

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,6 @@
-# Copyright (C) 2009-2021 Greenbone AG#
+# Copyright (C) 2009-2021 Greenbone AG
+#
 # SPDX-License-Identifier: AGPL-3.0-or-later
-#
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero General Public License as
-# published by the Free Software Foundation, either version 3 of the
-# License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero General Public License for more details.
-#
-# You should have received a copy of the GNU Affero General Public License
-# along with this program. If not, see <http://www.gnu.org/licenses/>.
 
 # Needed for 'pkg_check_modules' function
 include(FindPkgConfig)

=== debian/changelog ===
gsad (24.12.2-1) unstable; urgency=medium

  * New upstream version 24.12.2

 -- Sophie Brun <sophie@kali.org>  Thu, 08 Jan 2026 10:47:13 +0100
